git-commit.shon commit [PATCH] honor --author even with --amend, -C, and -c. (83e24dc)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Linus Torvalds
   4# Copyright (c) 2006 Junio C Hamano
   5
   6USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit>] [-u] [--amend] [-e] [--author <author>] [[-i | -o] <path>...]'
   7SUBDIRECTORY_OK=Yes
   8. git-sh-setup
   9require_work_tree
  10
  11git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
  12
  13case "$0" in
  14*status)
  15        status_only=t
  16        unmerged_ok_if_status=--unmerged ;;
  17*commit)
  18        status_only=
  19        unmerged_ok_if_status= ;;
  20esac
  21
  22refuse_partial () {
  23        echo >&2 "$1"
  24        echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
  25        exit 1
  26}
  27
  28THIS_INDEX="$GIT_DIR/index"
  29NEXT_INDEX="$GIT_DIR/next-index$$"
  30rm -f "$NEXT_INDEX"
  31save_index () {
  32        cp -p "$THIS_INDEX" "$NEXT_INDEX"
  33}
  34
  35run_status () {
  36        # If TMP_INDEX is defined, that means we are doing
  37        # "--only" partial commit, and that index file is used
  38        # to build the tree for the commit.  Otherwise, if
  39        # NEXT_INDEX exists, that is the index file used to
  40        # make the commit.  Otherwise we are using as-is commit
  41        # so the regular index file is what we use to compare.
  42        if test '' != "$TMP_INDEX"
  43        then
  44                GIT_INDEX_FILE="$TMP_INDEX"
  45                export GIT_INDEX_FILE
  46        elif test -f "$NEXT_INDEX"
  47        then
  48                GIT_INDEX_FILE="$NEXT_INDEX"
  49                export GIT_INDEX_FILE
  50        fi
  51
  52        case "$status_only" in
  53        t) color= ;;
  54        *) color=--nocolor ;;
  55        esac
  56        git-runstatus ${color} \
  57                ${verbose:+--verbose} \
  58                ${amend:+--amend} \
  59                ${untracked_files:+--untracked}
  60}
  61
  62trap '
  63        test -z "$TMP_INDEX" || {
  64                test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
  65        }
  66        rm -f "$NEXT_INDEX"
  67' 0
  68
  69################################################################
  70# Command line argument parsing and sanity checking
  71
  72all=
  73also=
  74only=
  75logfile=
  76use_commit=
  77amend=
  78edit_flag=
  79no_edit=
  80log_given=
  81log_message=
  82verify=t
  83quiet=
  84verbose=
  85signoff=
  86force_author=
  87only_include_assumed=
  88untracked_files=
  89while case "$#" in 0) break;; esac
  90do
  91        case "$1" in
  92        -F|--F|-f|--f|--fi|--fil|--file)
  93                case "$#" in 1) usage ;; esac
  94                shift
  95                no_edit=t
  96                log_given=t$log_given
  97                logfile="$1"
  98                shift
  99                ;;
 100        -F*|-f*)
 101                no_edit=t
 102                log_given=t$log_given
 103                logfile=`expr "z$1" : 'z-[Ff]\(.*\)'`
 104                shift
 105                ;;
 106        --F=*|--f=*|--fi=*|--fil=*|--file=*)
 107                no_edit=t
 108                log_given=t$log_given
 109                logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 110                shift
 111                ;;
 112        -a|--a|--al|--all)
 113                all=t
 114                shift
 115                ;;
 116        --au=*|--aut=*|--auth=*|--autho=*|--author=*)
 117                force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 118                shift
 119                ;;
 120        --au|--aut|--auth|--autho|--author)
 121                case "$#" in 1) usage ;; esac
 122                shift
 123                force_author="$1"
 124                shift
 125                ;;
 126        -e|--e|--ed|--edi|--edit)
 127                edit_flag=t
 128                shift
 129                ;;
 130        -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
 131                also=t
 132                shift
 133                ;;
 134        -o|--o|--on|--onl|--only)
 135                only=t
 136                shift
 137                ;;
 138        -m|--m|--me|--mes|--mess|--messa|--messag|--message)
 139                case "$#" in 1) usage ;; esac
 140                shift
 141                log_given=m$log_given
 142                if test "$log_message" = ''
 143                then
 144                    log_message="$1"
 145                else
 146                    log_message="$log_message
 147
 148$1"
 149                fi
 150                no_edit=t
 151                shift
 152                ;;
 153        -m*)
 154                log_given=m$log_given
 155                if test "$log_message" = ''
 156                then
 157                    log_message=`expr "z$1" : 'z-m\(.*\)'`
 158                else
 159                    log_message="$log_message
 160
 161`expr "z$1" : 'z-m\(.*\)'`"
 162                fi
 163                no_edit=t
 164                shift
 165                ;;
 166        --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
 167                log_given=m$log_given
 168                if test "$log_message" = ''
 169                then
 170                    log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 171                else
 172                    log_message="$log_message
 173
 174`expr "z$1" : 'zq-[^=]*=\(.*\)'`"
 175                fi
 176                no_edit=t
 177                shift
 178                ;;
 179        -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\
 180        --no-verify)
 181                verify=
 182                shift
 183                ;;
 184        --a|--am|--ame|--amen|--amend)
 185                amend=t
 186                log_given=t$log_given
 187                use_commit=HEAD
 188                shift
 189                ;;
 190        -c)
 191                case "$#" in 1) usage ;; esac
 192                shift
 193                log_given=t$log_given
 194                use_commit="$1"
 195                no_edit=
 196                shift
 197                ;;
 198        --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
 199        --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
 200        --reedit-messag=*|--reedit-message=*)
 201                log_given=t$log_given
 202                use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 203                no_edit=
 204                shift
 205                ;;
 206        --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
 207        --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\
 208        --reedit-message)
 209                case "$#" in 1) usage ;; esac
 210                shift
 211                log_given=t$log_given
 212                use_commit="$1"
 213                no_edit=
 214                shift
 215                ;;
 216        -C)
 217                case "$#" in 1) usage ;; esac
 218                shift
 219                log_given=t$log_given
 220                use_commit="$1"
 221                no_edit=t
 222                shift
 223                ;;
 224        --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
 225        --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
 226        --reuse-message=*)
 227                log_given=t$log_given
 228                use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 229                no_edit=t
 230                shift
 231                ;;
 232        --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
 233        --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
 234                case "$#" in 1) usage ;; esac
 235                shift
 236                log_given=t$log_given
 237                use_commit="$1"
 238                no_edit=t
 239                shift
 240                ;;
 241        -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
 242                signoff=t
 243                shift
 244                ;;
 245        -q|--q|--qu|--qui|--quie|--quiet)
 246                quiet=t
 247                shift
 248                ;;
 249        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 250                verbose=t
 251                shift
 252                ;;
 253        -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\
 254        --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\
 255        --untracked-file|--untracked-files)
 256                untracked_files=t
 257                shift
 258                ;;
 259        --)
 260                shift
 261                break
 262                ;;
 263        -*)
 264                usage
 265                ;;
 266        *)
 267                break
 268                ;;
 269        esac
 270done
 271case "$edit_flag" in t) no_edit= ;; esac
 272
 273################################################################
 274# Sanity check options
 275
 276case "$amend,$initial_commit" in
 277t,t)
 278        die "You do not have anything to amend." ;;
 279t,)
 280        if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
 281                die "You are in the middle of a merge -- cannot amend."
 282        fi ;;
 283esac
 284
 285case "$log_given" in
 286tt*)
 287        die "Only one of -c/-C/-F can be used." ;;
 288*tm*|*mt*)
 289        die "Option -m cannot be combined with -c/-C/-F." ;;
 290esac
 291
 292case "$#,$also,$only,$amend" in
 293*,t,t,*)
 294        die "Only one of --include/--only can be used." ;;
 2950,t,,* | 0,,t,)
 296        die "No paths with --include/--only does not make sense." ;;
 2970,,t,t)
 298        only_include_assumed="# Clever... amending the last one with dirty index." ;;
 2990,,,*)
 300        ;;
 301*,,,*)
 302        only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
 303        also=
 304        ;;
 305esac
 306unset only
 307case "$all,$also,$#" in
 308t,t,*)
 309        die "Cannot use -a and -i at the same time." ;;
 310t,,[1-9]*)
 311        die "Paths with -a does not make sense." ;;
 312,t,0)
 313        die "No paths with -i does not make sense." ;;
 314esac
 315
 316################################################################
 317# Prepare index to have a tree to be committed
 318
 319case "$all,$also" in
 320t,)
 321        save_index &&
 322        (
 323                cd_to_toplevel &&
 324                GIT_INDEX_FILE="$NEXT_INDEX" &&
 325                export GIT_INDEX_FILE &&
 326                git-diff-files --name-only -z |
 327                git-update-index --remove -z --stdin
 328        ) || exit
 329        ;;
 330,t)
 331        save_index &&
 332        git-ls-files --error-unmatch -- "$@" >/dev/null || exit
 333
 334        git-diff-files --name-only -z -- "$@"  |
 335        (
 336                cd_to_toplevel &&
 337                GIT_INDEX_FILE="$NEXT_INDEX" &&
 338                export GIT_INDEX_FILE &&
 339                git-update-index --remove -z --stdin
 340        ) || exit
 341        ;;
 342,)
 343        case "$#" in
 344        0)
 345                ;; # commit as-is
 346        *)
 347                if test -f "$GIT_DIR/MERGE_HEAD"
 348                then
 349                        refuse_partial "Cannot do a partial commit during a merge."
 350                fi
 351                TMP_INDEX="$GIT_DIR/tmp-index$$"
 352                commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
 353
 354                # Build a temporary index and update the real index
 355                # the same way.
 356                if test -z "$initial_commit"
 357                then
 358                        cp "$THIS_INDEX" "$TMP_INDEX"
 359                        GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
 360                else
 361                        rm -f "$TMP_INDEX"
 362                fi || exit
 363
 364                echo "$commit_only" |
 365                GIT_INDEX_FILE="$TMP_INDEX" \
 366                git-update-index --add --remove --stdin &&
 367
 368                save_index &&
 369                echo "$commit_only" |
 370                (
 371                        GIT_INDEX_FILE="$NEXT_INDEX"
 372                        export GIT_INDEX_FILE
 373                        git-update-index --remove --stdin
 374                ) || exit
 375                ;;
 376        esac
 377        ;;
 378esac
 379
 380################################################################
 381# If we do as-is commit, the index file will be THIS_INDEX,
 382# otherwise NEXT_INDEX after we make this commit.  We leave
 383# the index as is if we abort.
 384
 385if test -f "$NEXT_INDEX"
 386then
 387        USE_INDEX="$NEXT_INDEX"
 388else
 389        USE_INDEX="$THIS_INDEX"
 390fi
 391
 392GIT_INDEX_FILE="$USE_INDEX" \
 393        git-update-index -q $unmerged_ok_if_status --refresh || exit
 394
 395################################################################
 396# If the request is status, just show it and exit.
 397
 398case "$0" in
 399*status)
 400        run_status
 401        exit $?
 402esac
 403
 404################################################################
 405# Grab commit message, write out tree and make commit.
 406
 407if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
 408then
 409        if test "$TMP_INDEX"
 410        then
 411                GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
 412        else
 413                GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
 414        fi || exit
 415fi
 416
 417if test "$log_message" != ''
 418then
 419        echo "$log_message"
 420elif test "$logfile" != ""
 421then
 422        if test "$logfile" = -
 423        then
 424                test -t 0 &&
 425                echo >&2 "(reading log message from standard input)"
 426                cat
 427        else
 428                cat <"$logfile"
 429        fi
 430elif test "$use_commit" != ""
 431then
 432        encoding=$(git repo-config i18n.commitencoding || echo UTF-8)
 433        git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
 434        sed -e '1,/^$/d' -e 's/^    //'
 435elif test -f "$GIT_DIR/MERGE_MSG"
 436then
 437        cat "$GIT_DIR/MERGE_MSG"
 438elif test -f "$GIT_DIR/SQUASH_MSG"
 439then
 440        cat "$GIT_DIR/SQUASH_MSG"
 441fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
 442
 443case "$signoff" in
 444t)
 445        {
 446                echo
 447                git-var GIT_COMMITTER_IDENT | sed -e '
 448                        s/>.*/>/
 449                        s/^/Signed-off-by: /
 450                '
 451        } >>"$GIT_DIR"/COMMIT_EDITMSG
 452        ;;
 453esac
 454
 455if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
 456        echo "#"
 457        echo "# It looks like you may be committing a MERGE."
 458        echo "# If this is not correct, please remove the file"
 459        echo "# $GIT_DIR/MERGE_HEAD"
 460        echo "# and try again"
 461        echo "#"
 462fi >>"$GIT_DIR"/COMMIT_EDITMSG
 463
 464# Author
 465if test '' != "$use_commit"
 466then
 467        pick_author_script='
 468        /^author /{
 469                s/'\''/'\''\\'\'\''/g
 470                h
 471                s/^author \([^<]*\) <[^>]*> .*$/\1/
 472                s/'\''/'\''\'\'\''/g
 473                s/.*/GIT_AUTHOR_NAME='\''&'\''/p
 474
 475                g
 476                s/^author [^<]* <\([^>]*\)> .*$/\1/
 477                s/'\''/'\''\'\'\''/g
 478                s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
 479
 480                g
 481                s/^author [^<]* <[^>]*> \(.*\)$/\1/
 482                s/'\''/'\''\'\'\''/g
 483                s/.*/GIT_AUTHOR_DATE='\''&'\''/p
 484
 485                q
 486        }
 487        '
 488        encoding=$(git repo-config i18n.commitencoding || echo UTF-8)
 489        set_author_env=`git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
 490        LANG=C LC_ALL=C sed -ne "$pick_author_script"`
 491        eval "$set_author_env"
 492        export GIT_AUTHOR_NAME
 493        export GIT_AUTHOR_EMAIL
 494        export GIT_AUTHOR_DATE
 495fi
 496if test '' != "$force_author"
 497then
 498        GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
 499        GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
 500        test '' != "$GIT_AUTHOR_NAME" &&
 501        test '' != "$GIT_AUTHOR_EMAIL" ||
 502        die "malformed --author parameter"
 503        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
 504fi
 505
 506PARENTS="-p HEAD"
 507if test -z "$initial_commit"
 508then
 509        rloga='commit'
 510        if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
 511                rloga='commit (merge)'
 512                PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
 513        elif test -n "$amend"; then
 514                rloga='commit (amend)'
 515                PARENTS=$(git-cat-file commit HEAD |
 516                        sed -n -e '/^$/q' -e 's/^parent /-p /p')
 517        fi
 518        current="$(git-rev-parse --verify HEAD)"
 519else
 520        if [ -z "$(git-ls-files)" ]; then
 521                echo >&2 'nothing to commit (use "git add file1 file2" to include for commit)'
 522                exit 1
 523        fi
 524        PARENTS=""
 525        rloga='commit (initial)'
 526        current=''
 527fi
 528
 529if test -z "$no_edit"
 530then
 531        {
 532                echo ""
 533                echo "# Please enter the commit message for your changes."
 534                echo "# (Comment lines starting with '#' will not be included)"
 535                test -z "$only_include_assumed" || echo "$only_include_assumed"
 536                run_status
 537        } >>"$GIT_DIR"/COMMIT_EDITMSG
 538else
 539        # we need to check if there is anything to commit
 540        run_status >/dev/null 
 541fi
 542if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
 543then
 544        rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
 545        run_status
 546        exit 1
 547fi
 548
 549case "$no_edit" in
 550'')
 551        case "${VISUAL:-$EDITOR},$TERM" in
 552        ,dumb)
 553                echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
 554                echo >&2 "Please supply the commit log message using either"
 555                echo >&2 "-m or -F option.  A boilerplate log message has"
 556                echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
 557                exit 1
 558                ;;
 559        esac
 560        git-var GIT_AUTHOR_IDENT > /dev/null  || die
 561        git-var GIT_COMMITTER_IDENT > /dev/null  || die
 562        ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
 563        ;;
 564esac
 565
 566case "$verify" in
 567t)
 568        if test -x "$GIT_DIR"/hooks/commit-msg
 569        then
 570                "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
 571        fi
 572esac
 573
 574if test -z "$no_edit"
 575then
 576    sed -e '
 577        /^diff --git a\/.*/{
 578            s///
 579            q
 580        }
 581        /^#/d
 582    ' "$GIT_DIR"/COMMIT_EDITMSG
 583else
 584    cat "$GIT_DIR"/COMMIT_EDITMSG
 585fi |
 586git-stripspace >"$GIT_DIR"/COMMIT_MSG
 587
 588if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
 589        git-stripspace |
 590        wc -l` &&
 591   test 0 -lt $cnt
 592then
 593        if test -z "$TMP_INDEX"
 594        then
 595                tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
 596        else
 597                tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
 598                rm -f "$TMP_INDEX"
 599        fi &&
 600        commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
 601        rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
 602        git-update-ref -m "$rloga: $rlogm" HEAD $commit "$current" &&
 603        rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" &&
 604        if test -f "$NEXT_INDEX"
 605        then
 606                mv "$NEXT_INDEX" "$THIS_INDEX"
 607        else
 608                : ;# happy
 609        fi
 610else
 611        echo >&2 "* no commit message?  aborting commit."
 612        false
 613fi
 614ret="$?"
 615rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
 616if test -d "$GIT_DIR/rr-cache"
 617then
 618        git-rerere
 619fi
 620
 621if test "$ret" = 0
 622then
 623        if test -x "$GIT_DIR"/hooks/post-commit
 624        then
 625                "$GIT_DIR"/hooks/post-commit
 626        fi
 627        if test -z "$quiet"
 628        then
 629                echo "Created${initial_commit:+ initial} commit $commit"
 630                git-diff-tree --shortstat --summary --root --no-commit-id HEAD --
 631        fi
 632fi
 633
 634exit "$ret"